#Include "main.inc"

' It is a generally a good practice for each page to have its its own 
' Dialog box procedure. Even a page With only Static controls may still 
' need To Handle the wizard Button notification messages.

'==============================================================================
' WIZARD COMPLETION PAGE CALLBACK FUNCTION
'==============================================================================
CallBack Function CompletionDlgProc() As Long
   ' Process messages from the Completion page 
   
   Local lResult As Long
   Local hwndControl As Dword
    
   Local hwndDlg As Dword
   Local uMsg As Long
   Local wParam As Long
   Local lParam As Long
   
   
   Local lpnm As NMHDR Ptr
   
   
   hwndDlg   = CbHndl   'HWND hwndDlg   = CBHNDL  
   uMsg      = CbMsg    'UINT uMsg      = CBMSG
   wParam    = CbWParam 'WPARAM wParam  = CBWPARAM
   lParam    = CbLParam 'value points to a copy of the page's PROPSHEETPAGE 
                        ' structure. The lParam member Of this structure 
                        'is ignored by the system  
   
   
    'Get the Shared Data From PROPSHEETPAGE lParam value
   'And load it into GWL_USERDATA
   
   'Retrieve the Shared User Data From GWL_USERDATA
   
   ' To preserve access to the shared data structure for later use, 
   ' load it's pointer into the pages' user data by calling the 
   ' GetWindowLong Function With an index Of GWL_USERDATA                                                   
   Local pdata As Long Ptr
   pdata = GetWindowLong(hwndDlg, %GWL_USERDATA)
   
   Select Case (uMsg)
      
      ' When a page is about to be displayed for the first time, 
      ' its Dialog box procedure receives a WM_INITDIALOG message
      ' Handling this message allows the wizard to do any needed 
      ' initialization tasks   
      Case %WM_INITDIALOG
         
         ' The WM_INITDIALOG message's lParam value points to a copy of the 
         'page's PROPSHEETPAGE structure. The lParam member of this structure 
         'is ignored by the system. It typically points To an 
         'application-defined Shared Data structure that is used To store 
         'persistent Data And pass Data From one page To another.
         
         ' Get the Shared Data From PROPSHEETPAGE lParam value
         ' And load it into GWL_USERDATA                             
         pdata = lParam 
         lResult = SetWindowLong(hwndDlg, %GWL_USERDATA, pdata)
                                                                
         'It's an intro/end page, so get the title font
         'From  the Shared Data And use it For the title Control 
         hwndControl = GetDlgItem(hwndDlg, %IDS_TITLE2) 
          
         ' Set the Font                                         
         lResult = SendMessage(hWndControl, %WM_SETFONT, 0&, %TRUE)
            
      ' Notifications from the wizard come in the form of a WM_NOTIFY message. 
      ' You will receive this message before the page is displayed And when 
      ' Any Of the wizard's buttons are clicked   
      Case %WM_NOTIFY
         
         ' Get message
         lpnm = lParam 'lParam parameter of the message is a pointer to a NMHDR header structure  
         
         Select Case (@lpnm.code)   ' Check messages
            
            ' Just add code to the following messages as appropriate
            ' to handle all wizards messages.
            
            Case %PSN_SETACTIVE 'Sent before the page is displayed
            
               Call PropSheet_SetWizButtons(GetParent(hwndDlg), %PSWIZB_BACK Or %PSWIZB_FINISH)
            
            Case %PSN_WIZBACK                'Sent when the Back button is clicked
            Case %PSN_KILLACTIVE             'Notifies a page that it is about to lose activation either because another page is being activated or the user has clicked the OK button
            Case %PSN_APPLY                  'Sent to every page in the property sheet to indicate that the user has clicked the OK, Close, or Apply button and wants all changes to take effect
            Case %PSN_HELP                   'Notifies a page that the user has clicked the Help button
            Case %PSN_QUERYCANCEL            'Indicates that the user has canceled the property sheet
            Case %PSN_GETOBJECT              'Sent by a property sheet to request a drop target object when the cursor passes over one of the tab control's buttons
            Case %PSN_TRANSLATEACCELERATOR   'Notifies a property sheet that a keyboard message has been received. It provides the page an opportunity to do private keyboard accelerator translation
            Case %PSN_QUERYINITIALFOCUS      'Sent by a property sheet to provide a property sheet page an opportunity to specify which dialog box control should receive the initial focus  
            Case %PSN_RESET                  'Notifies a page that the property sheet is about to be destroyed
            Case %PSN_WIZFINISH              'Sent when the Finish button is clicked
               
         
         End Select
         
         
         
      Case %WM_DESTROY 
   
   End Select    
   
   
   Function = 0
End Function