#Include "Commctrl.inc"                ' Windows Common Control API definitions for PowerBASIC.

Sub ShowWizard(ByVal hDlg As Dword)
   Local lResult As Long
   
   Local psp As PROPSHEETPAGE       ' define the property sheet pages
   Local psh As PROPSHEETHEADER     ' define the property sheet 
   Local wizdata As SHAREDWIZDATA   ' define the shared data structure
   
   ' Reset struct's
   initPropSheetPage(psp)
   initPropSheetHeader(psh)
   initSharedWizData(wizdata)
   
   Local LPSHAREDWIZDATA As SHAREDWIZDATA Ptr     ' define pointer to the shared data structure
   LPSHAREDWIZDATA = VarPtr(wizdata)
   
   Local LPPROPSHEETHEADER As PROPSHEETHEADER Ptr  ' define pointer to the shared data structure
   LPPROPSHEETHEADER = VarPtr(psh)
   
   Local LPPROPSHEETPAGE As PROPSHEETPAGE Ptr      ' pointer to define the property sheet
   LPPROPSHEETPAGE = VarPtr(psp)  
    
   
   ' Array to hold the page's HPROPSHEETPAGE handles
   Dim ahpsp(3) As Dword   ' The ahpsp array, which is an array of HPROPSHEETPAGE handles    
   
   'Ensure that the common control DLL is loaded.
   'Load the common controls library...
   Local ticc          As INIT_COMMON_CONTROLSEX   ' specifies common control classes to register         
   Local icc As INIT_COMMON_CONTROLSEX
   ticc.dwSize = SizeOf(ticc)
   ticc.dwICC = %ICC_WIN95_CLASSES Or %ICC_INTERNET_CLASSES Or %ICC_STANDARD_CLASSES Or %ICC_TAB_CLASSES            
   'Call InitCommonControls()
   Call InitCommonControlsEx(icc)
  
   '===========================================================================
   ' Create the Wizard pages
   '===========================================================================
   '
   ' ***Welcome page
   '
   ' CreatePropertySheetPage 
   psp.dwSize        = SizeOf(psp)
   psp.dwFlags       = %PSP_DEFAULT Or %PSP_HIDEHEADER  
   psp.hInstance     = ghInstance
   psp.lParam        = LPSHAREDWIZDATA'pointer to wizdata shared data structure
   psp.pfnDlgProc    = CodePtr(IntroDlgProc) ' Pointer to callback
   psp.pszTemplate   = MakLng(%IDD_WIZ_WELCOME, 0)
   
   ' Welcome page HPROPSHEETPAGE handle is assigned to ahpsp(0). 
   ahpsp(0) = CreatePropertySheetPage(ByVal(LPPROPSHEETPAGE))
   '---------------------------------------------------------------------------
   '---------------------------------------------------------------------------
   '
   ' ***First interior page
   '
   ' CreatePropertySheetPage 
   psp.dwFlags = %PSP_DEFAULT Or %PSP_USEHEADERTITLE Or %PSP_USEHEADERSUBTITLE
   psp.pszHeaderTitle =    MakLng(%IDS_TITLE1, 0)
   psp.pszHeaderSubTitle = MakLng(%IDS_SUB_TITLE1, 0)  
   psp.pszTemplate = MakLng(%IDD_WIZ_PAGE1, 0)
   psp.pfnDlgProc = CodePtr(IntPage1DlgProc)
   
   ' First Interior page HPROPSHEETPAGE handle is assigned to ahpsp(1). 
   ahpsp(1) = CreatePropertySheetPage(ByVal(LPPROPSHEETPAGE))'(ByVal VarPtr (psp))
   '---------------------------------------------------------------------------
   '---------------------------------------------------------------------------
   ' ***Second interior page
   ' ***Third interior page
   ' ***etc...
   '---------------------------------------------------------------------------
   '---------------------------------------------------------------------------
   '
   ' ***Completion Page
   '
   ' CreatePropertySheetPage 
   psp.dwFlags = %PSP_DEFAULT Or %PSP_HIDEHEADER
   psp.pszTemplate = MakLng(%IDD_WIZ_COMPLETION, 0)
   psp.pfnDlgProc = CodePtr(CompletionDlgProc)
   
   ' Completion page HPROPSHEETPAGE handle is assigned to ahpsp(2). 
   ahpsp(2) = CreatePropertySheetPage(ByVal(LPPROPSHEETPAGE))'(ByVal VarPtr (psp))
   '---------------------------------------------------------------------------
   '---------------------------------------------------------------------------
   '
   '
   '***Create the property sheet
   '                          
   psh.dwSize = SizeOf(psh)
   psh.hInstance = ghInstance
   psh.hwndParent = %HWND_DESKTOP
   psh.phpage = VarPtr(ahpsp(0)) 
   
   ' Add or remove comment for the psh.dwFlags to 
   ' Enable Or diable Wizard97 Style
   '  Uncomment for Wizard97 style
   psh.dwFlags = %PSH_WIZARD97 Or %PSH_WATERMARK Or %PSH_HEADER
   '  Uncomment for Tab Style Wizard 
   'psh.dwFlags = %PSH_WATERMARK Or %PSH_HEADER 
   
   psh.pszbmWatermark = MakLng(%IDB_WIZ_WATERMARK, 0)
   psh.pszbmHeader = MakLng(%IDB_WIZ_BANNER, 0)
   psh.nStartPage = 0
   psh.nPages = 3
   
   '---------------------------------------------------------------------------
   ' FONTS
   '---------------------------------------------------------------------------
   ' Set up the font for the titles on the intro and ending pages
   '
   Local ncm As NONCLIENTMETRICS
   ncm.cbSize = SizeOf(ncm)
   Call SystemParametersInfo( %SPI_GETNONCLIENTMETRICS, SizeOf(ncm), ByVal VarPtr(ncm), 0)
   
   '
   ' Create the intro/end title font
   '
   Local hTitleLogFont As LOGFONT 
   hTitleLogFont = ncm.lfMessageFont 
   hTitleLogFont.lfWeight = %FW_BOLD
   hTitleLogFont.lfFaceName = "Verdana Bold" 
   
   Local hDC      As Dword
   Local lFontSize As Long
   
   hDC = GetDC(%HWND_DESKTOP) ' Gets the screen dc  
   lFontSize = 12
   hTitleLogFont.lfHeight = ( -MulDiv(lFontSize, GetDeviceCaps(hDC, %LOGPIXELSY), 72 ))'( 0 - GetDeviceCaps(hDC, %LOGPIXELSY)  * lFontSize \ 72)  
   
   wizdata.hTitleFont = CreateFontIndirect(ByVal VarPtr(hTitleLogFont))
   
   '---------------------------------------------------------------------------
   ' Display the wizard
   '
   Call PropertySheet(ByVal (LPPROPSHEETHEADER))
   ' ADD ERROR CHECKING CODE
   '
   'If ( GetLastError() <> 0 ) Then
   '   Exit Sub
   'End If
   '--------------------------------------------------------------------------- 
   '
   ' Destroy the font
   Call DeleteObject(wizdata.hTitleFont) 
   
End Sub

